package ch.hei.kart;

/**
 * Low-level interface in order to get changes from the remote Kart connected to a Kart object.
 * 
 * @author Michael Clausen (clm@hevs.ch)
 */
public interface KartStatusRegisterListener {
	/**
	 * This method is called by a Kart object where this listener has been registered for every
	 * register that changes its value.
	 * 
	 * @param kart		The Kart object where the register has changed.
	 * @param register	The actual register that has changed.
	 * @param newValue	The value of the register.
	 */
	public void statusRegisterHasChanged(Kart kart, KartStatusRegister register, int newValue);
}
