package ch.hei.kart.comm.transport.bluetooth;

import java.util.ArrayList;
import java.util.List;

import android.bluetooth.BluetoothDevice;

import ch.hei.kart.comm.discovery.DiscoveryEntity;
import ch.hei.kart.comm.protocol.Protocol;
import ch.hei.kart.comm.protocol.kartv1.KartV1Protocol;
import ch.hei.kart.comm.transport.Transport;

@SuppressWarnings("serial")
public class RfCommDiscoveryEntity implements DiscoveryEntity {
	public RfCommDiscoveryEntity(BluetoothDevice device) {
		this.deviceAddress = device.getAddress();
		this.deviceName = device.getName();
	}
	
	String getDeviceAddress() {
		return deviceAddress;
	}
	
	@Override
	public String getFriendlyName() {
		return deviceName;
	}

	@Override
	public String getDescription() {
		return "Bluetooth " + deviceAddress;
	}

	@Override
	public Class<? extends Transport> getTransportImplementation() {
		return RfCommTransport.class;
	}

	@Override
	public List<Class<? extends Protocol>> getSupportedProtocols() {
		List<Class<? extends Protocol>> protocols = new ArrayList<Class<? extends Protocol>>(1);
		protocols.add(KartV1Protocol.class);
		return protocols;
	}

	@Override
	public boolean equals(DiscoveryEntity other) {
		return getClass() == other.getClass() &&
				   deviceAddress.equals(((RfCommDiscoveryEntity)other).deviceAddress);
	}

	private String deviceAddress;
	private String deviceName;
}
